﻿''' <summary>
''' PlclikeClient サンプルプログラム
''' </summary>
Public Class Form1

    ''' <summary>
    ''' PlclikeClient 起動フォーム
    ''' </summary>
    Private fPlc As PlclikeClient.frmPLCSend

#Region "フォームイベント処理"
    ''' <summary>
    ''' フォーム：Loadイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    ''' <summary>
    ''' フォーム：Shownイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub Form1_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        '' Plclike起動状態の表示
        DispRunStatus(0)
    End Sub

    ''' <summary>
    ''' フォーム：FromClosingイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        '' Plclike 起動フォームが生成されている場合
        If (Not fPlc Is Nothing) Then
            '' PlclikeClient 実行確認、切断します。
            If (fPlc.RunMode = 1) Then
                '' PlclikeClientを停止します。
                fPlc.StopRun()
            End If
            '' 一応 PlclikeClient 起動フォームを終了しておきます。
            fPlc.Close()
            fPlc.Dispose()
        End If
    End Sub


#End Region

#Region "コントロールイベント処理"
    ''' <summary>
    ''' PlclikeClient 起動ボタンクリック
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub StartButton_Click(sender As Object, e As EventArgs) Handles StartButton.Click

        '' PlclikeClient 起動処理
        If (StartPlclike() = False) Then
            Return
        End If

        '' PlclikeClient 起動状態の表示
        DispRunStatus(0)

    End Sub

    ''' <summary>
    ''' PlclikeClient 実行・停止ボタンクリック
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub runStopButton_Click(sender As Object, e As EventArgs) Handles runStopButton.Click
        Dim iRes As Integer = -1
        Dim Message As String = ""

        '' PLC通信情報の有無
        If (fPlc Is Nothing) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        ElseIf (fPlc.IsDisposed = True) Then
            ''PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        End If

        '' 起動/実行確認
        If (fPlc.RunMode = 1) Then
            '' 通信切断開始
            iRes = fPlc.StopRun()
            If (iRes = 0) Then
                Message = "PLC通信を停止しました。"
                AddLoggingMessage(Message)
            Else
                Message = "PLC通信を停止時にエラーが発生しました。" + fPlc.ErrorMessage
                AddLoggingMessage(Message)
            End If
        Else
            '' 値設定情報が作成されていないようなら設定する
            If (Me.comboDevice.Items.Count <= 0) Then
                '' 設定情報取得
                SetCommboBoxDevice(True)
                Me.textAddress.Text = "0000"
                Me.textValue.Text = "0000"
                Me.textAddress2.Text = "0000"
                Me.textValue2.Text = "0000"
            End If

            '' 通信接続開始
            iRes = fPlc.StartRun()
            If (iRes = 0) Then
                Message = "PLC通信を実行しました。"
                AddLoggingMessage(Message)
            Else
                Message = "PLC通信を実行時にエラーが発生しました。" + fPlc.ErrorMessage
                AddLoggingMessage(Message)
            End If
        End If

        DispRunStatus(0)
    End Sub

    ''' <summary>
    ''' PlclikeClient 通信設定表示ボタンクリック
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub configButton_Click(sender As Object, e As EventArgs) Handles configButton.Click
        Dim bRes As Boolean = ConfigPlclike()
        If (bRes = False) Then
            Return
        End If
    End Sub

    ''' <summary>
    ''' 処理内容のクリアボタンイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub MessageClearButton_Click(sender As Object, e As EventArgs) Handles MessageClearButton.Click
        '' 処理内容クリア処理
        ClrLoggingMessage()
    End Sub

    ''' <summary>
    ''' メモリ読出しボタンイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub MemoryReadButton_Click(sender As Object, e As EventArgs) Handles MemoryReadButton.Click
        Dim sDevice As String = Me.comboDevice.Text
        Dim sAddress As String = Me.textAddress.Text
        Dim Message As String = ""

        '' PLC通信情報の有無
        If (fPlc Is Nothing) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        ElseIf (fPlc.IsDisposed = True) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        End If

        '' 読出し処理(イベント返信処理となります)
        Dim iCh As Integer = Me.numCh.Value
        Dim iRes As Integer = fPlc.SendRead(Me.comboDevice.SelectedIndex, Me.textAddress.Text, iCh)
        If (iRes < 0) Then
            Message += "読出送信エラー：" + fPlc.ErrorMessage
            AddLoggingMessage(Message)
        End If

    End Sub

    ''' <summary>
    ''' メモリ読出しボタンイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub MemoryReadButton2_Click(sender As Object, e As EventArgs) Handles MemoryReadButton2.Click
        Dim sDevice As String = Me.comboDevice.Text
        Dim sAddress As String = Me.textAddress.Text
        Dim sValue As String = ""
        Dim Message As String = ""

        '' PLC通信情報の有無
        If (fPlc Is Nothing) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        ElseIf (fPlc.IsDisposed = True) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        End If

        '' 読出し処理（返信があるまで処理は戻ってきません。）
        Dim iCh As Integer = Me.numCh.Value
        Dim iRes As Integer = fPlc.SendRead(Me.comboDevice.SelectedIndex, Me.textAddress.Text, iCh, sValue)
        If (iRes < 0) Then
            Message += "読出送信エラー：" + fPlc.ErrorMessage
            AddLoggingMessage(Message)
        Else
            '' 設定値代入
            Me.textValue.Text = sValue

            Message += "読出送信：" + sValue
            AddLoggingMessage(Message)
        End If

    End Sub

    ''' <summary>
    ''' メモリ書込みボタンイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub MemoryWriteButton_Click(sender As Object, e As EventArgs) Handles MemoryWriteButton.Click
        Dim sDevice As String = Me.comboDevice2.Text
        Dim sAddress As String = Me.textAddress2.Text
        Dim sValue As String = Me.textValue2.Text
        Dim Message As String = ""
        Dim iCh As Integer = Me.numCh2.Value
        Dim iCh2 As Integer
        Dim iRes As Integer = -1

        '' PLC通信情報の有無
        If (fPlc Is Nothing) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        ElseIf (fPlc.IsDisposed = True) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        End If

        '' 書込み値調整
        iCh2 = iCh * 4
        sValue = sValue.PadLeft(iCh2, "0")
        If (sValue.Length > iCh2) Then
            sValue = sValue.Substring(0, iCh2)
        End If
        If (Me.textValue2.Text.CompareTo(sValue) <> 0) Then
            Me.textValue2.Text = sValue
        End If

        '' 書込み処理
        iRes = fPlc.SendWrite(Me.comboDevice2.SelectedIndex, Me.textAddress2.Text, iCh, sValue)
        If (iRes < 0) Then
            Message += "書込送信エラー：" + fPlc.ErrorMessage
            AddLoggingMessage(Message)
        End If

    End Sub

    ''' <summary>
    ''' メモリ書込みボタンイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub MemoryWriteButton2_Click(sender As Object, e As EventArgs) Handles MemoryWriteButton2.Click
        Dim sDevice As String = Me.comboDevice2.Text
        Dim sAddress As String = Me.textAddress2.Text
        Dim sValue As String = Me.textValue2.Text
        Dim sResponse As String = ""
        Dim Message As String = ""
        Dim iCh As Integer = Me.numCh2.Value
        Dim iCh2 As Integer
        Dim iRes As Integer = -1

        '' PLC通信情報の有無
        If (fPlc Is Nothing) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        ElseIf (fPlc.IsDisposed = True) Then
            '' PLC通信起動確認警告
            Message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(Message)
            Return
        End If

        '' 書込み値調整
        iCh2 = iCh * 4
        sValue = sValue.PadLeft(iCh2, "0")
        If (sValue.Length > iCh2) Then
            sValue = sValue.Substring(0, iCh2)
        End If
        If (Me.textValue2.Text.CompareTo(sValue) <> 0) Then
            Me.textValue2.Text = sValue
        End If

        '' 書込み処理
        iRes = fPlc.SendWrite(Me.comboDevice2.SelectedIndex, Me.textAddress2.Text, iCh, sValue, sResponse)
        If (iRes < 0) Then
            Message += "書込送信エラー：" + fPlc.ErrorMessage
            AddLoggingMessage(Message)
        Else
            '' 書込み成功
            If (String.IsNullOrEmpty(fPlc.ErrorMessage) = False) Then

                sValue = fPlc.ErrorMessage
            End If
            Message += "書込送信：" + sResponse + "：" + sValue
            AddLoggingMessage(Message)
        End If

    End Sub

    ''' <summary>
    ''' 読取アドレス値入力ボタンクリックイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnADDRESS1_INPUT_Click(sender As Object, e As EventArgs) Handles btnADDRESS1_INPUT.Click
        Dim value As Integer = 0
        If (Not fPlc Is Nothing) Then
            If (Integer.TryParse(Me.textAddress.Text, value) = False) Then
                value = 0
            End If
            Dim defaultvalue As Integer = value
            '' 設定値入力
            '' 入力範囲：-2,147,483,648 ～ 2,147,483,647
            Dim sTitle As String = "読取りアドレスの入力"
            Dim iRes As Integer = fPlc.InputNumeric(-2147483648, 2147483647, defaultvalue, sTitle, value)
            If (iRes = 0) Then
                Me.textAddress.Text = value.ToString().PadLeft(4, "0")
            End If
        End If
    End Sub

    ''' <summary>
    ''' 読取設定値入力ボタンクリックイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnVALUE1_INPUT_Click(sender As Object, e As EventArgs) Handles btnVALUE1_INPUT.Click
        Dim cCommon As New Plclike.Libs.clsCommon()
        Dim value As Integer = 0
        If (Not fPlc Is Nothing) Then
            value = cCommon.Conv16to10(Me.textValue.Text)
            Dim defaultvalue As Integer = value
            '' 設定値入力
            '' 入力範囲：-2,147,483,648 ～ 2,147,483,647
            Dim sTitle As String = "設定値(16進数)の入力"
            Dim iRes As Integer = fPlc.InputHex(-2147483648, 2147483647, defaultvalue, sTitle, value)
            If (iRes = 0) Then
                Me.textValue.Text = cCommon.Conv10to16(value).ToUpper().PadLeft(4, "0")
            End If
        End If
    End Sub

    ''' <summary>
    ''' 書込アドレス値入力ボタンクリックイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnADDRESS2_INPUT_Click(sender As Object, e As EventArgs) Handles btnADDRESS2_INPUT.Click
        Dim value As Integer = 0
        If (Not fPlc Is Nothing) Then
            If (Integer.TryParse(Me.textAddress2.Text, value) = False) Then
                value = 0
            End If
            Dim defaultvalue As Integer = value
            '' 設定値入力
            '' 入力範囲：-2,147,483,648 ～ 2,147,483,647
            Dim sTitle As String = "書込みアドレスの入力"
            Dim iRes As Integer = fPlc.InputNumeric(-2147483648, 2147483647, defaultvalue, sTitle, value)
            If (iRes = 0) Then
                Me.textAddress2.Text = value.ToString().PadLeft(4, "0")
            End If
        End If
    End Sub

    ''' <summary>
    ''' 書込設定値入力ボタンクリックイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnVALUE2_INPUT_Click(sender As Object, e As EventArgs) Handles btnVALUE2_INPUT.Click
        Dim cCommon As New Plclike.Libs.clsCommon()
        Dim value As Integer = 0
        If (Not fPlc Is Nothing) Then
            value = cCommon.Conv16to10(Me.textValue2.Text)
            Dim defaultvalue As Integer = value
            '' 設定値入力
            '' 入力範囲：-2,147,483,648 ～ 2,147,483,647
            Dim sTitle As String = "設定値(16進数)の入力"
            Dim iRes As Integer = fPlc.InputHex(-2147483648, 2147483647, defaultvalue, sTitle, value)
            If (iRes = 0) Then
                Me.textValue2.Text = cCommon.Conv10to16(value).ToUpper().PadLeft(4, "0")
            End If
        End If
    End Sub
#End Region

#Region "内部処理"

    ''' <summary>
    ''' PlclikeClient 実行状態取得
    ''' </summary>
    ''' <returns>0=停止、1=実行、それ以外=未定義</returns>
    Private Function GetRunStatus() As Integer
        Dim iRes As Integer = -1
        Dim sMessage As String = ""
        Try
            If (fPlc Is Nothing) Then
                '' 未定義
                iRes = -1
            ElseIf (fPlc.IsDisposed = True) Then
                '' 未定義
                iRes = -1
            ElseIf (fPlc.RunMode = 1) Then
                '' 起動中
                iRes = 1
            Else
                '' 停止中
                iRes = 0
            End If
        Catch e As Exception
            '' 例外エラー
            iRes = -2
            sMessage = e.Message
        End Try

        Return iRes
    End Function

    ''' <summary>
    ''' PlclikeClient 実行状態取得
    ''' </summary>
    ''' <returns>状態情報(例：起動中 等)</returns>
    Private Function GetRunStatusName() As String
        Dim sMessage As String = ""

        Try
            If (fPlc Is Nothing) Then
                sMessage = "未処理"
            ElseIf (fPlc.IsDisposed = True) Then
                sMessage = "未処理"
            ElseIf (fPlc.RunMode = 1) Then
                sMessage = "起動中"
            Else
                sMessage = "停止中"
            End If
        Catch e As Exception
            sMessage = "例外エラー：" + e.Message
        End Try

        Return sMessage
    End Function

    ''' <summary>
    ''' PlclikeClient 起動状態
    ''' </summary>
    ''' <param name="iFlag">0=Open/Closes処理時,1=Dispose処理時</param>
    Private Sub DispRunStatus(iFlag As Integer)
        '' 接続状態表示
        Dim sMessage As String = GetRunStatusName()
        Me.lblRunStatus.Text = "PlclikeClientの状態：" + sMessage
        '' 起動・停止ボタン表示切替
        If (GetRunStatus() = 1) Then
            Me.runStopButton.Text = "接続停止"
            Me.runStopButton.ForeColor = Color.Red
        Else
            Me.runStopButton.Text = "実行開始"
            Me.runStopButton.ForeColor = Color.Blue
        End If
    End Sub

    ''' <summary>
    ''' PlclikeClient 初期処理
    ''' </summary>
    Private Sub InitPlclike()
        '' Plclike 起動フォームが未生成なので生成します。
        fPlc = New PlclikeClient.frmPLCSend()
        fPlc.dgtTransferOpenClose = New PlclikeClient.frmPLCSend.SetTransferOpenClose(AddressOf ChangeTransferOpenClose)
        fPlc.dgtTransferMemory = New PlclikeClient.frmPLCSend.SetTransferMemory(AddressOf ChangePLCData)
        'fPlc.Disposed = New EventHandler(AddressOf ChangeTransferDispose)
    End Sub

    ''' <summary>
    ''' PlclikeClient設定情報起動
    ''' </summary>
    ''' <returns></returns>
    Private Function ConfigPlclike() As Boolean
        Dim bRes As Boolean = False
        Dim message As String = ""

        '' 処理内容へ表示
        message = "PlclikeClient 通信設定開始"
        AddLoggingMessage(message)

        '' Plclike 起動フォーム生成判定
        If (fPlc Is Nothing) Then
            '' Plclike 起動フォームが未生成なので生成します。
            InitPlclike()
        ElseIf (fPlc.IsDisposed = True) Then
            '' Plclike 起動フォームが未生成なので生成します。
            InitPlclike()
        End If

        '' Plclike 通信設定を実行
        bRes = fPlc.StartTransferConfig()
        If (bRes = False) Then
            MessageBox.Show("通信設定をキャンセル、または設定失敗だったので処理を中断します・・・",
                    "設定確認", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End If

        Return True
    End Function

    ''' <summary>
    ''' PlclikeClient 起動
    ''' </summary>
    ''' <returns></returns>
    Private Function StartPlclike() As Boolean
        Dim bRes As Boolean = False
        Dim message As String = ""

        '' 処理内容へ表示
        message = "PlclikeClient 起動開始"
        AddLoggingMessage(message)

        '' Plclike 起動フォーム生成判定
        If (fPlc Is Nothing) Then
            '' Plclike 起動フォームが未生成なので生成します。
            InitPlclike()
        ElseIf (fPlc.IsDisposed = True) Then
            '' Plclike 起動フォームが未生成なので生成します。
            InitPlclike()
        Else
            message = "PlclikeClient はすでに実行中です"
            AddLoggingMessage(message)
            If (Me.radioButton1.Checked = True) Then
                If (fPlc.Visible = False) Then
                    message = "PlclikeClient はすでに実行中ですが、PlclikeClient は非表示です。" + vbCrLf
                    message += "PlilikeClient を表示しますか？"
                    If (MessageBox.Show(message, "起動確認", MessageBoxButtons.YesNo _
                                        , MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button2) = DialogResult.Yes) Then

                        fPlc.Visible = True
                    End If
                    Return True
                End If
            Else
                If (fPlc.Visible = True) Then
                    message = "PlclikeClient はすでに実行中です。" + vbCrLf
                    message += "PlilikeClient を非表示しますか？"
                    If (MessageBox.Show(message, "起動確認", MessageBoxButtons.YesNo _
                            , MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button2) = DialogResult.Yes) Then

                        fPlc.Visible = False
                    End If
                    Return True
                End If
            End If
            Return True
        End If

        '' Plclike 起動フォーム実行判定
        If (Me.radioButton1.Checked = True) Then
            '' PlclikeClient 起動フォームを表示して実行
            message = "PlclikeClient 起動画面を表示して実行"
            AddLoggingMessage(message)
            fPlc.Show()
        Else
            '' PlcLikeClient 起動フォームを非表示で実行
            message = "PlclikeClient 起動画面を非表示して実行"
            AddLoggingMessage(message)
            fPlc.ShowHide()
        End If

        '' PlclikeClient ライセンス確認
        If (fPlc.LicenseFlag = False) Then
            If (MessageBox.Show("ライセンス認証されていないようです・・・" + vbCrLf +
                    "ライセンス認証されていない場合、設定ファイル等は使用できませんので設定する必要があります。" + vbCrLf +
                    "設定する場合は「はい」、中断する場合は「いいえ」を選択してください", "ライセンス確認",
                    MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.No) Then

                '' 処理の中断
                Return False
            End If

            '' PlclikeClient 通信設定を実行
            bRes = ConfigPlclike()
            If (bRes = False) Then
                Return False
            End If
        End If

        '' 設定情報取得
        SetCommboBoxDevice(True)
        Me.textAddress.Text = "0000"
        Me.textValue.Text = ""
        Me.textAddress2.Text = "0000"
        Me.textValue2.Text = "0000"

        Return True
    End Function

    ''' <summary>
    ''' デバイス名称生成
    ''' </summary>
    ''' <param name="default_value">既定値使用区分(true=設定,false=未設定)</param>
    Private Sub SetCommboBoxDevice(default_value As Boolean)
        Dim iMax As Integer = -1
        Dim iLp As Integer = -1
        Dim message As String = ""
        Dim value As String = ""

        '' PLC通信情報の有無
        If (fPlc Is Nothing) Then
            '' PLC通信起動確認警告
            message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(message)
            Return
        ElseIf (fPlc.IsDisposed = True) Then
            '' PLC通信起動確認警告
            message = "PLC通信情報が実行されていません。まず、「実行」ボタンをクリックしPLC通信を起動してください。"
            AddLoggingMessage(message)
            Return
        End If

        '' 値設定初期化
        fPlc.CreateComboDeviceRead(Me.comboDevice)

        fPlc.CreateComboDeviceWrite(Me.comboDevice2)

        If (default_value = True) Then
            If (Me.comboDevice.Items.Count >= 1) Then
                Me.comboDevice.SelectedIndex = 0
            End If
            If (Me.comboDevice2.Items.Count >= 1) Then
                Me.comboDevice2.SelectedIndex = 0

            End If
        End If

    End Sub

#Region "＞処理内容表示処理"

    ''' <summary>
    ''' 処理内容メッセージ初期化
    ''' </summary>
    Private Sub ClrLoggingMessage()
        Me.textPlclike.Text = ""
    End Sub

    ''' <summary>
    ''' 処理内容メッセージ追記
    ''' </summary>
    ''' <param name="value">メッセージ文字列</param>
    Private Sub AddLoggingMessage(value As String)
        '' 既定は、先頭へメッセージ文字列を追記します。
        AddLoggingessage(value, 0, True)
    End Sub

    ''' <summary>
    ''' 処理内容メッセージ追記
    ''' </summary>
    ''' <param name="value">メッセージ文字列</param>
    ''' <param name="top_or_bottom">メッセージ追記区分(0=先頭に追記,1=終端へ追記)</param>
    ''' <param name="disp_time">処理内容に日時付加有無(true=日時を追加,false=日時を非表示)</param>
    Private Sub AddLoggingessage(value As String, top_or_bottom As Integer, disp_time As Boolean)

        '' メッセージ指定確認
        If (String.IsNullOrEmpty(value) = True) Then
            '' メッセージが無い場合は処理を中断
            Return
        End If
        Dim Message As String = ""

        '' 日時表記有無
        If (disp_time = True) Then
            Message = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " "
        End If
        Message += value

        '' メッセージ追加
        If (top_or_bottom = 1) Then
            Me.textPlclike.Text += vbCrLf + Message
        Else
            Me.textPlclike.Text = Message + vbCrLf + Me.textPlclike.Text
        End If
    End Sub
#End Region

#Region "＞イベント処理"
    ''' <summary>
    ''' PlclikeClient 起動/停止 切替イベント
    ''' </summary>
    ''' <param name="iSerialNo">登録番号[未使用]</param>
    Private Sub ChangeTransferOpenClose(iSerialNo As Integer)
        '' PlclikeClient 起動状態確認
        DispRunStatus(0)
    End Sub

    ''' <summary>
    ''' PlclikeClient 終了時 イベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ChangeTransferDispose(sender As Object, e As EventArgs)
        '' Plclike 起動状態確認
        DispRunStatus(1)
    End Sub

    ''' <summary>
    ''' 読取り・書込みイベント処理
    ''' </summary>
    ''' <param name="iSerialNo">シリアル番号</param>
    ''' <param name="iMode">入力区分</param>
    ''' <param name="sDevice">デバイス</param>
    ''' <param name="sAddress">アドレス</param>
    ''' <param name="sResponce">書込戻り値</param>
    ''' <param name="sMemoryData">読取取得値</param>
    Private Sub ChangePLCData(iSerialNo As Integer, iMode As Integer, sDevice As String, sAddress As String, sResponce As String, sMemoryData As String)
        If (Me.InvokeRequired = True) Then
            Dim d As New PlclikeClient.frmPLCSend.SetTransferMemory(AddressOf ChangePLCDataSub)
            Dim ar As IAsyncResult = Me.BeginInvoke(d, New Object() {iSerialNo, iMode, sDevice, sAddress, sResponce, sMemoryData})
        Else
            ChangePLCDataSub(iSerialNo, iMode, sDevice, sAddress, sResponce, sMemoryData)
        End If
    End Sub

    ''' <summary>
    ''' 読取り・書込みイベント処理
    ''' </summary>
    ''' <param name="iSerialNo">シリアル番号</param>
    ''' <param name="iMode">入力区分</param>
    ''' <param name="sDevice">デバイス</param>
    ''' <param name="sAddress">アドレス</param>
    ''' <param name="sResponce">書込戻り値</param>
    ''' <param name="sMemoryData">読取取得値</param>
    Public Sub ChangePLCDataSub(iSerialNo As Integer, iMode As Integer, sDevice As String, sAddress As String, sResponce As String, sMemoryData As String)
        Dim Message As String = ""

        '' 読出しイベント処理の場合にログ出力処理
        If (iMode = 0) Then
            '' イベント取得情報を代入
            Message = String.Format(" PLC読出しイベント: SerialNo[{0}] Device[{1}] Address[{2}] Responce[{3}] DATA[{4}]", iSerialNo.ToString(), sDevice, sAddress, sResponce, sMemoryData)

            '' 処理内容へ表示
            AddLoggingMessage(Message)

            '' 取得値をコントロールへ代入
            Me.textValue.Text = sMemoryData
        End If
        '' 書込みイベント処理の場合にログ出力処理
        If (iMode = 1) Then
            '' イベント取得情報を代入
            Message = String.Format(" PLC書込みイベント: SerialNo[{0}] Device[{1}] Address[{2}] Responce[{3}] DATA[{4}]", iSerialNo.ToString(), sDevice, sAddress, sResponce, sMemoryData)

            '' 処理内容へ表示
            AddLoggingMessage(Message)
        End If
    End Sub


#End Region

#End Region

End Class
